import connect from 'connect';
import http from 'http';
import serveStatic from 'serve-static';
import path from 'path';

// src/ci.coffee
function ci(opts) {
  return task('test:ci', 'Run tests', function(opts) {
    return invoke('test', {
      bail: true,
      coverage: true,
      ci: true
    });
  });
}

// src/server.coffee

function server$1(opts) {
  var ref;
  if (opts.port == null) {
    opts.port = (ref = process.env.PORT) != null ? ref : 3333;
  }
  if (opts.dir == null) {
    opts.dir = process.cwd() + '/test/fixtures';
  }
  if (opts.message == null) {
    opts.message = 'Run static server for tests';
  }
  if (opts.name == null) {
    opts.name = 'server';
  }
  return task(opts.name, opts.message, function(cb) {
    var app;
    app = connect();
    app.use(serveStatic(opts.dir));
    return http.createServer(app).listen(opts.port, cb);
  });
}

// node_modules/find-coffee/lib/find-coffee.mjs

// node_modules/es-tostring/index.mjs
var toString = function(obj) {
  return Object.prototype.toString.call(obj)
};

// node_modules/es-hasown/index.mjs

// node_modules/es-is/bool.js
// Generated by CoffeeScript 1.12.5
var isBool;

var isBool$1 = isBool = function(value) {
  return toString(value) === '[object Boolean]';
};

// node_modules/es-is/infinite.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/number.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/array-like.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/array.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/function.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/object.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/arguments.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/async-function.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/string.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/base64.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/date.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/utils.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/decimal.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/defined.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/divisible-by.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/element.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/empty-arguments.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/empty-array.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/empty.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/equal.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/error.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/even.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/false.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/generator-function.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/generator.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/ge.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/gt.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/hash.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/hex.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/hosted.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/instanceof.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/integer.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/le.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/lt.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/max.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/min.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/nan.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/null.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/odd.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/primitive.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/promise.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/regexp.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/symbol.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/true.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/type.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/undefined.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/valid-date.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/within.js
// Generated by CoffeeScript 1.12.5

// node_modules/es-is/index.mjs
// Generated by CoffeeScript 1.12.5

// src/index.coffee
var findCoffee;
var resolveCoffee;
var version;

// Check version of coffee found
version = function(coffeePath) {
  var pkg;
  pkg = require(path.resolve(coffeePath, '../../../package.json'));
  return parseInt((pkg.version.split('.'))[0], 10);
};

// Resolve specific version of coffee, matching either package name
resolveCoffee = function(wanted) {
  var coffeePath, i, len, pkg, ref;
  ref = ['coffeescript', 'coffee-script'];
  for (i = 0, len = ref.length; i < len; i++) {
    pkg = ref[i];
    try {
      coffeePath = require.resolve(pkg);
      if ((version(coffeePath)) === wanted) {
        return coffeePath;
      }
    } catch (error) {
      
    }
  }
  throw new Error('Unable to find CoffeeScript matching version ' + wanted);
};

// Find and return coffee version, or alternately just path
var index = findCoffee = function(wanted, lazy) {
  var pkgPath;
  if (isBool$1(wanted)) {
    [wanted, lazy] = [lazy, wanted];
  }
  // Default to 2, but take accept 1
  if (!((wanted != null) || wanted === 'any')) {
    try {
      return findCoffee(2, lazy);
    } catch (error) {
      return findCoffee(1, lazy);
    }
  }
  // Resolve path to package
  pkgPath = resolveCoffee(wanted);
  // If lazy only return path
  if (lazy) {
    return pkgPath;
  } else {
    return require(pkgPath);
  }
};

// src/test.coffee

function test(opts) {
  return task('test', 'Run tests', function*(opts) {
    var addons, bail, bin, cmd, coffee, coffeePath, coverage, env, grep, k, lazy, ref, ref1, ref2, ref3, ref4, ref5, status, test, v, verbose;
    bail = (ref = opts.bail) != null ? ref : true;
    coverage = (ref1 = opts.coverage) != null ? ref1 : false;
    grep = (ref2 = opts.grep) != null ? ref2 : '';
    test = (ref3 = opts.test) != null ? ref3 : 'test/';
    verbose = (ref4 = opts.verbose) != null ? ref4 : '';
    if (opts.requireBuild) {
      yield invoke('build');
    }
    if (opts.serveStatic) {
      yield invoke('server', opts.serveStatic);
    }
    bin = require.resolve('mocha/bin/mocha');
    if (bail) {
      bail = '--bail';
    }
    if (grep) {
      grep = `--grep ${opts.grep}`;
    }
    // Default env variables for tests
    env = {
      NODE_ENV: 'test'
    };
    if (verbose) {
      env.VERBOSE = 'true';
    }
    // Setup addons to have mocha to require
    addons = ['--require co-mocha'];
    try {
      // Detect coffeescript
      coffeePath = index(lazy = true);
      coffee = ~coffeePath.indexOf('coffee-script') ? 'coffee-script' : 'coffeescript';
      addons.push(`--compilers coffee:${coffee}/register`);
      if (coverage) {
        addons.push('--require coffee-coverage/register-istanbul');
      }
    } catch (error) {
    }
    try {
      // Detect sake-chai
      require.resolve('sake-chai');
      addons.push('--require sake-chai/register');
    } catch (error) {
    }
    // Coverage configuration
    if (coverage) {
      bin = 'istanbul --print=none cover _mocha --';
    } else {
      addons.push('--require postmortem/register');
    }
    ref5 = opts.env;
    // Update env with anything passed
    for (k in ref5) {
      v = ref5[k];
      env[k] = v;
    }
    // Generate env exports
    env = ((function() {
      var results;
      results = [];
      for (k in env) {
        v = env[k];
        results.push(k + '=' + v);
      }
      return results;
    })()).join(' ');
    // Build mocha command
    cmd = `${env} ${bin} --colors --reporter spec --timeout 10000000 ${addons.join(' ')} --recursive ${bail} ${grep} ${test}`;
    // Run tests and capture status
    ({status} = (yield exec.interactive(cmd)));
    if (opts.serveStatic) {
      // Close server
      server.close();
    }
    if (status) {
      // Exit with test status if non-zero
      return process.exit(status);
    }
  });
}

// src/watch.coffee
function watch(opts) {
  return task('test:watch', 'watch for changes and re-run tests', function() {
    invoke('watch');
    return require('vigil').watch(__dirname, function(filename, stats) {
      if (/^src/.test(filename)) {
        invoke('test');
      }
      if (/^test/.test(filename)) {
        return invoke('test', {
          test: filename
        });
      }
    });
  });
}

// src/index.coffee

function index$1(opts = {}) {
  ci(opts);
  server$1(opts);
  test(opts);
  return watch(opts);
}

export default index$1;
//# sourceMappingURL=sake-mocha.mjs.map
